CON
  _clkmode      = xtal1 + pll16x                        ' use crystal x 16
  _xinfreq      = 5_000_000
   
OBJ
  tch:           "Touch"                                 ' touchscreen driver

PUB Main | touchtest  ' debug value
  tch.Begin(2,false)                                          ' display type 2 = dual ILI9325, false means run a program not the desktop so don't load icons
  Buttons
  tch.SetWarmBoot                                           ' clears screen, sets a warm boot and reboots

PUB Buttons | ck1x,ck1y,ck1s,ck2x,ck2y,ck2s,rd1x,rd1y,rd1s,rd2x,rd2y,rd2s,rd3x,rd3y,rd3s,bu1x,bu1y,xval,yval,redraw,f,f2,sx1,sy1,sx2,sy2 ' test out buttons, radio buttons, checkboxes 
   tch.SetOrientation(true)                             ' portrait view
   tch.ClearRam                                          ' file 0 and 1 reserved
   tch.Clearscreen(tch.RGBtoWord(212,208,200))       ' background gray color determined from paintshop
   tch.Textbox(10,200,120,215)                          ' clear a text box. height = fontheight+1?
   f := tch.Loadfont(string("MSans14W.ifn"))            ' file 2 black on white font
   tch.setcurx(12)                                      ' x = x1+2 in textboxclear and see lorem for displaying text from an sd card
   tch.setcury(201)                                     ' y = y1 in textboxclear
   tch.TextT(f,string("This is a textbox"))             ' draw text for the textbox
   f2 := tch.Loadfont(string("MSans14.ifn"))            ' file 3 black on gray 14 point seems to be the same as 8.25 in vb.net ? why
   tch.SDBMPtoRam(string("butn8430.bmp"))               ' file 4 a button 84x30 in size
   tch.SDBMPtoRam(string("Uncheckd.bmp"))               ' file 5 unchecked checkbox pic3
   tch.SDBMPtoRam(string("Checked.bmp"))                ' file 6 checked checkbox pic4
   tch.SDBMPtoRam(string("RadioUnc.bmp"))               ' file 7 unchecked radiobox pic 5
   tch.SDBMPtoRam(string("RadioChk.bmp"))               ' file 8 checked radiobox pic 6
   tch.SDBMPtoRam(string("hot120.bmp"))                 ' file 9 picturebox demo
   tch.DrawBMPRam(9,115,10)                             ' draw file 9
   tch.stringdim(5)                                     ' file 9 is the strings
   tch.stringstore(0,string("Ok"))                      ' store string for the ok button
   redraw := true    
   ' set all the locations of the objects on the screen
   sx1:=130                                            ' select box (similar to a multiline text box)
   sy1:=160
   sx2:=230
   sy2:=260
   tch.Selectbox(sx1,sy1,sx2,sy2)                       ' draw a multiline selectbox
   tch.MoveVerticalScroll(sx2,sy1,sy2,0)                   ' scrollbar to item 0 (0-255)
   ck1x := ck2x := rd1x := rd2x := rd3x := 20           ' x all the same 
   ck1y := 10    
   ck2y := ck1y + 40                                    ' y coordinates
   rd1y := ck2y + 40
   rd2y := rd1y + 40
   rd3y := rd2y + 40
   bu1x := 80                                           ' button position
   bu1y := 280
   ck1s := true                                         ' startup status
   ck2s := false
   rd1s := true
   rd2s := false
   rd3s := false
   ' now wait for touch
   tch.SelectSPIGroup                                   ' talk to the spi touchscreen
   repeat
      if redraw                                         ' if redraw true then redraw all the objects
         tch.SelectMemGroup                             ' display mode
         tch.DrawCheckbox(ck1x,ck1y,ck1s,string("Check1"),5,6,f2)        ' checkbox
         tch.DrawCheckbox(ck2x,ck2y,ck2s,string("Check2"),5,6,f2)        ' checkbox
         tch.DrawRadiobox(rd1x,rd1y,rd1s,string("Radiobutton1"),7,8,f2)     ' radiobox
         tch.DrawRadiobox(rd2x,rd2y,rd2s,string("Radiobutton1"),7,8,f2)     ' radiobox 
         tch.DrawRadiobox(rd3x,rd3y,rd3s,string("Radiobutton2"),7,8,f2)     ' radiobox
         tch.DrawButton(bu1x,bu1y,0,4,f2)                         ' button (fixed size at the moment)
         redraw := false
         tch.SelectSPIGroup                             ' talk to the spi touchscreen  
      yval := tch.TouchYPercent                         ' decode yval 0-100%                
      xval := tch.TouchXPercent                         ' decode xval 0-100%
      if (xval <> 255)  and (yval <> 255)               ' valid keypress
        xval := (xval * 24) / 10                        ' scale to pixels as can measure from the picture in paintshop
        yval := (yval * 32) / 10                        ' scale to pixels
        if xval < 100
          case yval
            (ck1y-10)..(ck1y+25): !ck1s                   ' checkbox is small so active area bigger than the checkbox
                                  redraw := true          ' redraw the screen
            (ck2y-10)..(ck2y+25): !ck2s                   ' checkbox is small so active area bigger than the checkbox
                                  redraw := true         
            (rd1y-10)..(rd1y+25): rd1s :=   true            ' there probably is a smarter way to make one value true and all the rest false
                                  rd2s :=   false
                                  rd3s :=   false                   
                                  redraw := true
            (rd2y-10)..(rd2y+25): rd1s :=   false            
                                  rd2s :=   true
                                  rd3s :=   false                   
                                  redraw := true
            (rd3y-10)..(rd3y+25): rd1s :=   false            
                                  rd2s :=   false
                                  rd3s :=   true                  
                                  redraw := true
          tch.pause1ms(250)                               ' debounce 
                                     
        case yval
          bu1y..(bu1y + 30): return                     ' button so exit this screen

        if (xval > sx2 - 25) and (xval < sx2+10) and (yval > sy1) and (yval < sy2) ' slider knob
           tch.SelectMemGroup                             ' display mode
           tch.MoveVerticalScroll(sx2,sy1,sy2,yval)      ' there is some maths based on sy1, sy2 and yval to work out a percentage  
           tch.SelectSPIGroup                             ' talk to the spi touchscreen    