CON
  _clkmode      = xtal1 + pll16x                        ' use crystal x 16
  _xinfreq      = 5_000_000
   
OBJ
  tch:           "Touch"                                 ' touchscreen driver

PUB Main | touchtest  ' debug value
  tch.Begin(2,false)                                          ' display type 2 = dual ILI9325, false means run a program not the desktop so don't load icons
  Keyboard
  tch.SetWarmBoot                                           ' clears screen, sets a warm boot and reboots

PUB Keyboard | capslock, backspace,xval,yval,address,ascii,f
   tch.Clearscreen(%00000000_00000000)                  ' clear the screen
   tch.SetOrientation(false)                            ' landscape view
   tch.ClearRam
   f := tch.Loadfont(string("Arial30.ifn"))             ' font = file 2
   tch.DrawBMPRam(tch.SDBMPtoRam(string("KeyL.bmp")),0,0) ' load and draw in one command
   tch.stringdim(10)                                    ' reserve some string space
   capslock := 0 ' default to off                       ' caps lock 
   backspace := 0 'default to off                       ' backspace is zero
   tch.stringclear(0)                                   ' clear this string
   tch.SelectSPIGroup                                   ' talk to the spi touchscreen
   tch.SetCursor(4,27)                                  ' cursor to top left with the margin
   repeat
      xval := tch.TouchYPercent                       ' decode yval 0-100%  and swap x and y as this is landscape mode              
      yval := tch.TouchXPercent                      ' decode xval 0-100%
      if (xval <> 255)  and (yval <> 255)               ' valid keypress
        tch.SelectMemGroup                              ' displaying now
        address :=255
        ascii := 255
        xval := (xval * 32) / 10                        ' scale to pixels as can measure from the picture in paintshop
        yval := 240 - ((yval * 24) / 10)                ' scale to pixels and org top left                        
        case yval
          133..162:address := xval / 32                 ' top row qwertyuiop
          163..188:address := 10 + ((xval-17) / 32)     ' second row addres 10 up, offset
          189..214:address := 19 + ((xval -47) / 32)    ' third row, includes two buttons in one
                   if xval<47
                     address := 255                     ' non printing character capslock
                     !capslock                          ' toggle capslock
                   if xval >273
                     !backspace                         ' backspace character
          215..239:if xval >64 and xval < 256
                      address := 26                     ' space bar 
                   if xval>256
                      address :=27                      ' carriage return (LF added below)   
        if address < 255 and backspace == 0
           ascii := lookupz(address: "Q","W","E","R","T","Y","U","I","O","P","A","S","D","F","G","H","J","K","L","Z","X","C","V","B","N","M",32,13)
          if (capslock == 0) and (ascii => 65) and (ascii =< 90) 
            ascii += 32                                 ' lower case              
          tch.setcurx(tch.TextChar(f,ascii,tch.getcurx,tch.getcury)) ' only print if a valid ascii character
          tch.StringAddChar(0,ascii)
          if ascii == 13                                ' add line feed if this is a return
            ascii := 10                                 ' add LF
            tch.setcurx(tch.TextChar(f,ascii,tch.getcurx,tch.getcury)) ' display line feed
            tch.StringAddChar(0,ascii)
        if backspace <>0                                ' backspace redraws the entire string buffer
          backspace := 0                                ' backspace now zero
          tch.StringSubChar(0)                          ' remove rightmost character
          tch.ClearRectangle(0,22,319,132,tch.GetBackFontColor) ' clear an area the same color as the font background
          tch.SetCursor(4,27)                           ' top left of the screen with the margin
          tch.StringPrint(f,0)                          ' print string 0
          
        if xval => 0 and xval <45 and yval => 0 and yval <21
          return                                        ' cancel button
        if xval => 280 and xval < 320 and yval => 0 and yval <21
          result := 0                            ' the 'send' button returns string 0 (or could return @rambuffer)
          return
        tch.pause1ms(250)                               ' debounce
        tch.SelectSPIGroup                              ' wait for next keypress